<?php

define ('NO_RESOURCES', 1);
require ('globals.php');
if (!@include ('config.php')) {
	exit ('Config file unreadable!');
}
if (!@include ('dbconn.php')) {
	exit ('Database config file unreadable!');
}

// Updater version
$update_ver = '5.5.6';

// Init
$debug = 0;
$mem = $OekakiPoteto_MemberPrefix;
$pre = $OekakiPoteto_Prefix;
$sql_errors = array();

function run_q($query) {
	global $sql_errors, $debug;

	if ($debug) {
		web_line ('DEBUG:  '.$query);
	}
	$result = mysql_query ($query);
	if (!$result) {
		$sql_errors[] = mysql_error();
	} else {
		return ($result);
	}
}

function web_line($in = '') {
	echo ($in."<br />\n");
}

function fail_exit() {
	global $dbconn;

	mysql_close ($dbconn);
	web_line ();
	web_line ('If problems persist, try visiting the <a href="http://www.ninechime.com/forum/">NineChime Support Forum</a>.');
	exit();
}

function fix_cfg_quotes($in) {
	/*
		Strip ALL backslashes and replace with proper quotes.  Due to OP quirks, single quotes should be left alone.
		Consecutive backslashes are a big problem with OP 5.x.
		Note that html decoders are mostly PHP5, and not in all RCs, either.  Grr.
	*/

	$in = str_replace ('\\', '', $in);
	$in = str_replace ('"', '&quot;', $in);
	$in = addslashes ($in);
	$in = str_replace ("\\'", '\'', $in);

	return ($in);
}

function get_fields($table) {
	global $dbconn;
	$names = array();

	$result = mysql_query ("SHOW FIELDS FROM ".$table);
	if ($result) {
		$rows = mysql_num_rows ($result);
		for ($i=0; $i < $rows; $i++) {
			$temp = mysql_fetch_row ($result);
			$names[] = $temp[0];
		}
		return ($names);
	} else {
		return (FALSE);
	}
}


// Fix for MySQL 5 (don't add stuff yet)
run_q ("ALTER TABLE {$mem}oekaki CHANGE templatesel templatesel varchar(255) NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$mem}oekakichat CHANGE comment comment TINYTEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$mem}oekakichat CHANGE hostname hostname TEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$mem}oekakichat CHANGE `IP` `IP` TEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$mem}oekakionline CHANGE onlineIP onlineIP TEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$mem}oekakionline CHANGE onlineboard onlineboard TEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$mem}oekakimailbox CHANGE subject subject TEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$mem}oekakimailbox CHANGE body body LONGTEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$mem}oekakichatmod CHANGE comment comment TINYTEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$mem}oekakichatmod CHANGE hostname hostname TEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$mem}oekakichatmod CHANGE `IP` `IP` TEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$mem}oekakichatmodusers CHANGE usrname usrname VARCHAR(255) NOT NULL DEFAULT ''");

run_q ("ALTER TABLE {$pre}oekakicmt CHANGE comment comment TEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$pre}oekakicmt CHANGE hostname hostname TEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$pre}oekakicmt CHANGE `IP` `IP` TEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$pre}oekakidta CHANGE comment comment TEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$pre}oekakidta CHANGE hostname hostname TEXT NOT NULL DEFAULT ''");
run_q ("ALTER TABLE {$pre}oekakidta CHANGE `IP` `IP` TEXT NOT NULL DEFAULT ''");

run_q ("ALTER TABLE {$mem}oekaki ADD avatar VARCHAR(128) NOT NULL DEFAULT ''");


// Remove files
if (file_exists ('redirect.php') && !$debug) {
	@unlink ('redirect.php');
}
if (file_exists ('arecover.php') && !$debug) {
	@unlink ('arecover.php');
}
if (file_exists ('flagchk.php')) {
	@unlink ('flagchk.php');
}

exit ('Done!  Delete this file from the server.');

?>